"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const indexer_1 = __importDefault(require("@statoscope/helpers/dist/indexer"));
const makeAPI = (source) => {
    const packageIndexes = new Map();
    const instanceIndexes = new Map();
    for (const compilation of source.payload.compilations) {
        packageIndexes.set(compilation.id, (0, indexer_1.default)((r) => r.name, compilation.packages));
        for (const packageItem of compilation.packages) {
            instanceIndexes.set(packageItem, (0, indexer_1.default)((r) => r.path, packageItem.instances));
        }
    }
    return {
        getPackage(compilationId, packageId) {
            var _a, _b, _c, _d;
            return ((_d = (_b = (_a = packageIndexes.get(compilationId)) === null || _a === void 0 ? void 0 : _a.get(packageId)) !== null && _b !== void 0 ? _b : (_c = packageIndexes.get(null)) === null || _c === void 0 ? void 0 : _c.get(packageId)) !== null && _d !== void 0 ? _d : null);
        },
        getInstance(compilationId, packageId, instancePath) {
            var _a, _b, _c, _d, _e, _f;
            const resolvedPackage = (_d = (_b = (_a = packageIndexes.get(compilationId)) === null || _a === void 0 ? void 0 : _a.get(packageId)) !== null && _b !== void 0 ? _b : (_c = packageIndexes.get(null)) === null || _c === void 0 ? void 0 : _c.get(packageId)) !== null && _d !== void 0 ? _d : null;
            if (!resolvedPackage) {
                return null;
            }
            return (_f = (_e = instanceIndexes.get(resolvedPackage)) === null || _e === void 0 ? void 0 : _e.get(instancePath)) !== null && _f !== void 0 ? _f : null;
        },
    };
};
exports.default = makeAPI;
//# sourceMappingURL=api.js.map