import { Extension, ExtensionDescriptor } from '@statoscope/stats/spec/extension';
export type Format = Extension<Payload>;
export type InstanceInfo = {
    version: string;
};
export type Instance = {
    path: string;
    info: InstanceInfo;
};
export type Package = {
    name: string;
    instances: Array<Instance>;
};
export type Compilation = {
    id: string | null;
    packages: Array<Package>;
};
export type Payload = {
    compilations: Array<Compilation>;
};
export default class Generator {
    private adapter?;
    private packageResolvers;
    private instanceResolvers;
    private descriptor;
    private payload;
    private resolveCompilation;
    constructor(adapter?: ExtensionDescriptor | undefined);
    handleInstance(compilationId: string | null, packageName: string, instance: string, info: InstanceInfo): void;
    get(): Format;
}
